; mIRC Extension for San Andreas
; Author: Arushan (aru)
; The following code is based off Luke's (Smithers) mIRC script

;;; Actions ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
on 1:LOAD:{
  saInstall
}
on *:TEXT:*:#:{ if ($chan iswm %sa.channel) { 
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16777215,string,$+(<,$nick,>) $strip($1-))
    .comclose vbcom
  }
}
on *:ACTION:*:#:{ if ($chan iswm %sa.channel) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,65280,string,* $nick $strip($1-)))
    .comclose vbcom
  }
}
on *:INPUT:*:{ if ($chan iswm %sa.channel) {
    set %sa.temp.value $strip($1-)
    set %sa.temp.leftone $left(%sa.temp.value,1)
    set %sa.temp.leftone.enc /
    set %sa.temp.me $left(%sa.temp.value,4)
    set %sa.temp.me.enc /me
    .comopen vbcom SanAn.clsMessage
    if (%sa.temp.me == %sa.temp.me.enc) {
      var %result = $com(vbcom,AddChat,1,long,65280,string,* $me $strip($2-)))
    } 
    else {
      if (%sa.temp.leftone == %sa.temp.leftone.enc) {
        var %result = $com(vbcom,AddChat,1,long,16777215,string,[Command] $- $strip($1-))
      } 
      else {
        var %result = $com(vbcom,AddChat,1,long,16777215,string,$+(<,$me,>) $strip($1-))
      }
    }
    .comclose vbcom
    unset %sa.temp.*
  }
}
on *:TOPIC:#:{ if ($chan iswm %sa.channel) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16776960,string,* $nick changes topic to $- $strip($1-))
    .comclose vbcom
  }
}
on *:MODE:#:{ if ($chan iswm %sa.channel) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16776960,string,* $nick sets mode: $1-)
    .comclose vbcom
  }
}
on *:QUIT:{
  if (($network == %sa.network) && ($nick ison %sa.channel)) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16776960,string,* $nick Quit ( $strip($1-) ))
    .comclose vbcom
  }
}
on *:NICK:{
  if ($newnick ison %sa.channel) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16776960,string,* $nick is now known as $newnick)
    .comclose vbcom
  }
}
on *:JOIN:#:{ if ($chan iswm %sa.channel) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16776960,string,* $nick joined $chan)
    .comclose vbcom
  }
}
on *:PART:#:{ if ($chan iswm %sa.channel) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16776960,string,* $nick left $chan ( $strip($1-) ))
    .comclose vbcom
  }
}
on *:KICK:#:{ if ($chan iswm %sa.channel) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16776960,string,* $knick was kicked by $nick $- ( $strip($1-) ))
    .comclose vbcom
  }
}
on *:BAN:#:{ if ($chan iswm %sa.channel) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16776960,string,* $nick sets mode: +b $- $strip($banmask))
    .comclose vbcom
  }
}
on *:UNBAN:#:{ if ($chan iswm %sa.channel) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16776960,string,* $nick sets mode: -b $- $strip($banmask))
    .comclose vbcom
  }
}
on *:OP:#:{ if ($chan iswm %sa.channel) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16776960,string,* $nick sets mode: +o $opnick)
    .comclose vbcom
  }
}
on *:DEOP:#:{ if ($chan iswm %sa.channel) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16776960,string,* $nick sets mode: -o $opnick)
    .comclose vbcom
  }
}
on *:VOICE:#:{ if ($chan iswm %sa.channel) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16776960,string,* $nick sets mode: +v $vnick)
    .comclose vbcom
  }
}
on *:DEVOICE:#:{ if ($chan iswm %sa.channel) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16776960,string,* $nick sets mode: -v $vnick)
    .comclose vbcom
  }
}
on *:NOTICE:#:{ if ($chan iswm %sa.channel) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16777215,string,$+(-,$nick,-) $strip($1-))
    .comclose vbcom
  }
}

;;; DDE Call Aliases ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
alias saExecute {
  if (%sa.found == 1) {
    scid %sa.cid $1-
  }
}
alias saSay {
  if (%sa.found == 1) {
    scid %sa.cid /msg %sa.channel $1-
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16777215,string,$+(<,$me,>) $strip($1-))
    .comclose vbcom
  }
}
alias saMe {
  if (%sa.found == 1) {
    scid %sa.cid /describe %sa.channel $1-
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,65280,string,* $me $strip($1-)))
    .comclose vbcom
  }
}
alias saInit {
  unset %sa.cid
  set %sa.found 0
  set %sa.temp.conns $scid(0)
  var %sa.temp.i = 1
  while (%sa.temp.i <= %sa.temp.conns) {
    set %sa.temp.scid $scid(%sa.temp.i)
    scid %sa.temp.scid /saGetNetwork
    if (%sa.temp.network == %sa.network) {
      set %sa.found 1
      set %sa.cid %sa.temp.scid
      break
    }
    inc %sa.temp.i
  }
  if (%sa.found == 0) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16777215,string,*** Error: Failed to find network $- %sa.network)
    .comclose vbcom
  }
  if (%sa.found == 1) {
    scid %sa.cid /join %sa.channel
    timerSA -im 1 750 /saVerify
  }
  unset %sa.temp.*
}

;;; Helper Aliases ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
alias saVerify {
  if ($me !ison %sa.channel) {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16777215,string,*** Error: Cound not join channel $- %sa.channel)
    .comclose vbcom
  } 
  else {
    .comopen vbcom SanAn.clsMessage
    var %result = $com(vbcom,AddChat,1,long,16777215,string,* Now talking in $- %sa.channel)
    var %result = $com(vbcom,AddChat,1,long,16777215,string,* Topic is $- $strip($chan(%sa.channel).topic))
    .comclose vbcom
  }
}
alias saGetNetwork {
  set %sa.temp.network $network
}
alias saInstall {
  comreg $+(",$scriptdir,gtasa_mirc.dll,")
  if (%sa.config != 1) {
    saConfig
  }
}
alias saUninstall {
  unset %sa.*
  comreg -u $+(",$scriptdir,gtasa_mirc.dll,")
  unload -rs sanan.mrc
}
alias saConfig {
  dialog -m saCfgDlg saConfigDialog
  did -a saCfgDlg 3 %sa.network
  did -a saCfgDlg 4 %sa.channel
}

;;; Status Menu ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
menu status {
  San Andreas Extension
  .Configuration:/saConfig
  .Uninstall:/saUninstall
}

;;; Configuration Dialog ;;;;;;;;;;;;;;;;;;;;;;;;;;
dialog -l saConfigDialog {
  title San Andreas Extension Configuration
  size -1 -1 220 100
  text "Network:", 1, 10 10 50 20
  text "Channel:", 2, 10 35 50 20
  edit "", 3, 60 7 150 20, autohs
  edit "", 4, 60 32 150 20, autohs
  button "OK", 5, 60 65 70 25, default ok
  button "Cancel", 6, 140 65 70 25, cancel
}
on *:dialog:saCfgDlg:sclick:5: {
  set %sa.network $did(saCfgDlg,3)
  set %sa.channel $did(saCfgDlg,4)
  set %sa.config 1
}
